<template>
    <main-master-page>
        <div class="text-main-title">Analytics Pixel Player</div>
        <div><date-range-picker :class="$style['block-space']" /></div>
        <kpi-block :items="kpiItems" :class="$style['block-space']" />
        <chart-component title="Impressions by hours" :chart-data="chartData" :class="$style['block-space']" />
        <chart-component title="Impressions by days" :chart-data="graphDataDaily" :class="$style['block-space']" />

        <tables-section :items="impressionsByDays" :columns="impressionsByDaysColumns" :class="$style['block-space']" />
    </main-master-page>
</template>

<script>
import MainMasterPage from '@/masterpages/MainMasterPage.vue'
import DateRangePicker from '@/components/DateRangePicker.vue'
import KpiBlock from '@/components/KpiBlock'
import ChartComponent from '@/components/ChartComponent.vue'
import TablesSection from '@/components/TablesSection.vue'
import { formatBigNumbers } from '@/utils/utils'
import { useDailyStore } from '@/store/modules/daily'
import { useHourlyStore } from '@/store/modules/hourly'
import { mapState } from 'pinia'
import { monthsShort } from '@/constants/generalConstants'
export default {
    name: 'PixelDashboard',

    components: {
        DateRangePicker,
        KpiBlock,
        ChartComponent,
        MainMasterPage,
        TablesSection,
    },

    data() {
        return {
            date: null,
            kpiItems: [
                {
                    label: 'Impressions',
                    number: 77,
                    comment: 'comment',
                    bgColor: '#ffdcdd',
                    color: '#f01527',
                },
                {
                    label: 'Impressions',
                    number: 77,
                    comment: 'comment',
                    bgColor: '#ffdcdd',
                    color: '#f01527',
                },
            ],
            chartData: {
                labels: [1, 2, 3, 4, 5, 6, 7],
                datasets: [
                    {
                        label: 'Impression per hour',
                        // backgroundColor: '#f87979',
                        data: [40, 39, 10, 40, 39, 80, 40],
                        tension: 0.3,
                        pointRadius: 0,
                        borderColor: '#c319ee',
                        backgroundColor: '#c319ee',
                    },
                ],
            },
            chartData2: {
                labels: [1, 2, 3, 4, 5, 6, 7],
                datasets: [
                    {
                        label: 'Impression per day',
                        // backgroundColor: '#f87979',
                        data: [40, 39, 10, 40, 39, 80, 40],
                        tension: 0.3,
                        pointRadius: 0,
                        borderColor: '#c319ee',
                        backgroundColor: '#c319ee',
                    },
                ],
            },
            impressionsByHour: [
                { hour: 0, impressions: 28754 },
                { hour: 1, impressions: 20432 },
                { hour: 2, impressions: 15214 },
                { hour: 3, impressions: 12457 },
                { hour: 4, impressions: 8213 },
                { hour: 5, impressions: 2930 },
                { hour: 6, impressions: 12389 },
                { hour: 7, impressions: 24611 },
                { hour: 8, impressions: 29009 },
                { hour: 9, impressions: 18128 },
                { hour: 10, impressions: 2798 },
                { hour: 11, impressions: 24422 },
                { hour: 12, impressions: 14567 },
                { hour: 13, impressions: 10503 },
                { hour: 14, impressions: 28357 },
                { hour: 15, impressions: 16689 },
                { hour: 16, impressions: 21777 },
                { hour: 17, impressions: 23122 },
                { hour: 18, impressions: 29835 },
                { hour: 19, impressions: 25094 },
                { hour: 20, impressions: 13460 },
                { hour: 21, impressions: 17583 },
                { hour: 22, impressions: 25787 },
                { hour: 23, impressions: 28703 },
            ],
            impressionsByHoursColumns: [
                {
                    field: 'hour',
                    label: 'Hour',
                    width: '40',
                    numeric: true,
                },
                {
                    field: 'impressions',
                    label: 'Impressions',
                    formatValue: formatBigNumbers,
                },
            ],
            impressionsByDaysColumns: [
                {
                    field: 'day',
                    label: 'Day',
                    numeric: true,
                },
                {
                    field: 'impressions',
                    label: 'Impressions',
                    numeric: true,
                    formatValue: formatBigNumbers,
                },
            ],
        }
    },

    computed: {
        ...mapState(useDailyStore, ['dailyList']),
        ...mapState(useHourlyStore, ['hourlyList']),
        impressionsByDays() {
            return this.dailyList.map((day) => ({
                day: this.getCorrectDate(day.date),
                impressions: day.impressions,
            }))
        },

        // datehour
        // :
        // "2023-11-25T00Z"
        // impressions
        // :
        // 4
        hourlyDataDaily() {
            const labels = []
            const data = []
            this.hourlyList.forEach((hour) => {
                labels.push(this.getShortDate(hour.date))
                data.push(hour.impressions)
            })
            return {
                labels,
                datasets: [
                    {
                        label: 'Impression per hour',
                        // backgroundColor: '#f87979',
                        data,
                        tension: 0.3,
                        pointRadius: 0,
                        borderColor: '#c319ee',
                        backgroundColor: '#c319ee',
                    },
                ],
            }
        },
        graphDataDaily() {
            const labels = []
            const data = []
            this.dailyList.forEach((day) => {
                labels.push(this.getShortDate(day.date))
                data.push(day.impressions)
            })
            return {
                labels,
                datasets: [
                    {
                        label: 'Impression per day',
                        // backgroundColor: '#f87979',
                        data,
                        tension: 0.3,
                        pointRadius: 0,
                        borderColor: '#c319ee',
                        backgroundColor: '#c319ee',
                    },
                ],
            }
        },
    },

    methods: {
        getCorrectDate(date) {
            const arr = date.split('-')
            return `${arr[2]}/${arr[1]}/${arr[0]}`
        },
        getShortDate(date) {
            const arr = date.split('-')
            return `${arr[2]} ${monthsShort[parseInt(arr[1]) - 1]}`
        },
        getShortDayDate(date) {
            const arr = new Date(date)
            return `${arr.getUTCHours()} ${monthsShort[arr.getMonth()]} ${monthsShort[arr.getDay()]} `
        },
    },
}
</script>

<style lang="scss" module>
@import '@/assets/styles/variables';
.block-space {
    margin-top: 64px;
}
</style>
